﻿#region MIT Licenze
//The MIT License

//Copyright (c) 2008 Sebastian Faltoni, dotnetfireball.org

//Permission is hereby granted, free of charge, to any person obtaining a copy
//of this software and associated documentation files (the "Software"), to deal
//in the Software without restriction, including without limitation the rights
//to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
//copies of the Software, and to permit persons to whom the Software is
//furnished to do so, subject to the following conditions:

//The above copyright notice and this permission notice shall be included in
//all copies or substantial portions of the Software.

//THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
//IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
//FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
//AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
//LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
//OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
//THE SOFTWARE.
#endregion
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Media;
using System.IO;
using System.Runtime.Serialization.Formatters.Binary;
using System.Xml.Serialization;

namespace Fireball.ImagePak
{
    [Serializable]
    public sealed class ImageInfo
    {
        
        internal static ImageInfo Deserialize(Stream strm)
        {
           /* BinaryFormatter bin = new BinaryFormatter();
           
            return (ImageInfo)bin.Deserialize(strm);*/

            XmlSerializer xmlSerializer = new XmlSerializer(typeof(ImageInfo));
            return (ImageInfo)xmlSerializer.Deserialize(strm);
        }

        internal static void Serialize(ImageInfo info,Stream strm)
        {
            XmlSerializer xmlSerializer = new XmlSerializer(typeof(ImageInfo));
            xmlSerializer.Serialize(strm, info);
            /*BinaryFormatter bin = new BinaryFormatter();
            bin.Serialize(strm, info);*/
        }
        
        public string ContentType
        {
            get;
            set;
        }

        
        public double Width
        {
            get;
            set;
        }

        public double Height
        {
            get;
            set;
        }

        public double Stride
        {
            get;
            set;
        }

        public PixelFormat PixelFormat
        {
            get;
            set;
        }
    }
}
