﻿using System;
using System.Text;
using System.Collections.Generic;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Fireball.ImagePak;
using System.IO;
using System.Windows.Media;

namespace ImagePakTests
{
    /// <summary>
    /// Summary description for UnitTest1
    /// </summary>
    [TestClass]
    public class PackageTests
    {
        public PackageTests()
        {
            //
            // TODO: Add constructor logic here
            //
        }

        private TestContext testContextInstance;

        /// <summary>
        ///Gets or sets the test context which provides
        ///information about and functionality for the current test run.
        ///</summary>
        public TestContext TestContext
        {
            get
            {
                return testContextInstance;
            }
            set
            {
                testContextInstance = value;
            }
        }

        #region Additional test attributes
        //
        // You can use the following additional attributes as you write your tests:
        //
        // Use ClassInitialize to run code before running the first test in the class
        // [ClassInitialize()]
        // public static void MyClassInitialize(TestContext testContext) { }
        //
        // Use ClassCleanup to run code after all tests in a class have run
        // [ClassCleanup()]
        // public static void MyClassCleanup() { }
        //
        // Use TestInitialize to run code before running each test 
        // [TestInitialize()]
        // public void MyTestInitialize() { }
        //
        // Use TestCleanup to run code after each test has run
        // [TestCleanup()]
        // public void MyTestCleanup() { }
        //
        #endregion

        [TestMethod]
        public void CreatePackage()
        {
            try
            {
                ImagePackage imp = ImagePackage.Create(Path.GetFullPath("o:/test.zip"));

                var strm = typeof(PackageTests).Assembly.GetManifestResourceStream("ImagePakTests.Garden.jpg");

                byte[] bts = new byte[strm.Length];
                strm.Read(bts, 0, (int)strm.Length);
                strm.Close();

                var im = imp.Datas.AddMainImage("image/jpg");

                im.SetInfo(new ImageInfo()
                {
                    ContentType = "image/jpg",
                    Depth = 32,
                    Width = 100,
                    Height = 100,
                    PixelFormat = PixelFormats.Bgra32
                });

                using (var imStrm = im.GetStream())
                {
                    imStrm.Write(bts, 0, bts.Length);
                    imStrm.Flush();
                    imStrm.Close();
                }

                imp.Close();
            }
            catch (Exception ex)
            {
                Assert.Fail(ex.ToString());
            }
        }
    }
}
